require "bin/math"
require "conf"
require "player"
require "entity"
require "map"
require "menu"
require "gui"
require "console"

function love.load()
	--Basic Variable crap
	timer = 0
	
	--Font crap
	smallF = love.graphics.newFont(12)
	mediumF = love.graphics.newFont(16)
	largeF = love.graphics.newFont(18)
	
	--Entity startup crap
	entity.startup()
	
	--Mouse crap
	love.mouse.setGrabbed(true)
	love.mouse.setVisible(false)
	
	--Cursor crap
	cursorNormal = love.graphics.newImage("bin/images/cursors/cursor_normal.png")
	--cursorSelect = love.graphics.newImage("bin/images/cursers/cursor_select.png")
	cursorTarget = love.graphics.newImage("bin/images/cursors/cursor_target.png")
	--cursorGrab = love.graphics.newImage("bin/images/cursors/cursor_grab.png")
	--cursorDrag = love.graphics.newImage("bin/images/cursors/cursor_drag.png")
	
	--GameState crap
	gameState = "mainMenu"
	
	--GUI startup crap
	guiAM("Teleport", "teleport")
	guiAM("Option_2", "Action_2")
	guiAM("Option_3", "Action_3")
	guiAM("Option_4", "Action_4")
	guiAM("Option_5", "Action_5")
	
	--Preplaced tiles crap
	tile.new(0,0)
end

function love.draw()
	--Playing crap
	if gameState == "playing" then
		love.graphics.setBackgroundColor(223,223,233)
		tile:draw()
		playerDraw()
		entity:draw()
		guiDraw()
		love.graphics.draw(cursorNormal,mouseX,mouseY)
	end
	
	--MainMenu crap
	if gameState == "mainMenu" then
		menuDraw()
	end
	
	--Debug crap
	if debugMode == true then
		love.graphics.setFont(mediumF)
		love.graphics.setColor(0,0,0)
		love.graphics.print("FPS: "..fps, 15, 15)
		love.graphics.print("Time: "..math.round(timer),15, 35)
		love.graphics.print("# of entities: ".. #entity.objects,15, 55)
	end
	
	--Console crap
	consoleDraw()
	
	--This game is crap
end

function love.update(dt)
	--Mouse Crap
	mouseX, mouseY = love.mouse.getPosition()
	
	--More Playing crap
	if gameState == "playing" then
		tile:update(dt)
		playerUpdate(dt)
		entity:update(dt)
		guiUpdate(dt)
	end
	
	--More MainMenu crap
	if gameState == "mainMenu" then
		menuUpdate(dt)
	end
	
	--Sum More Console crap
	consoleUpdate(dt)
	
	--Superfluous crap
	fps = love.timer.getFPS()
	timer = timer + dt
end

function love.keypressed(key)
	--Keyboard crap
	consoleKeyboard(key)
	menuKeyboard(key)
	guiKeyboard(key)
	
	--Universal Key crap
	if key == "tab" then
		love.event.quit()
	end
end

function love.mousepressed(x, y, button)
	--Start Click crap
	guiStartClick(x, y, button )
end

function love.mousereleased(x, y, button)
	--End Click crap (why do we need this?)
	guiEndClick(x, y, button )
	--We need it for dragging crap idiot! ^^^
end

function love.textinput(t)
	--Keyboard Stroke input crap
	consoleCmd(t)
	menuInput(t)
end

function love.quit()
	--[[
		save shizzle
		]]
end