--Table crap
menuLog = {
}

--Variable crap
local menuText = ""

function menuDraw()
	--Drawing crap
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setFont(largeF)
	love.graphics.setColor(0,255,0)
	love.graphics.print(">:", 25, 560)
	love.graphics.print(menuText, 50, 560)
	local y = 530
	love.graphics.setFont(mediumF)
	for k,v in pairs(menuLog) do
		love.graphics.print(v,45,y)
		y = y - 16
	end
	
	--Blinking Cursor crap
	if #menuText > 0 then
		if math.ceil(math.round(timer)%2) == 0 then
			love.graphics.print("_", largeF:getWidth(menuText) + 50, 560)
		end
	else
		if math.ceil(math.round(timer)%2) == 0 then
			love.graphics.print("_", 50, 560)
		end
	end
end

function clearLog()
	--cls command crap
	for i = #menuLog, 1, -1 do
		table.remove(menuLog, i)
	end
end

function mLog(message)
	--Simplified menu entry crap
	table.insert(menuLog, 1, message)
end

function menuUpdate(dt)
	--Stop from too much crap getting in the log crap
	if gameState == "mainMenu" then
		if #menuLog >= 33 then
			table.remove(menuLog, #menuLog)
		end
	end
end

function menuKeyboard(key)
	--Keyboard crap
	if key == "backspace" and gameState == "mainMenu" and string.len(menuText) > 0 then
		menuText = string.sub(menuText, 1, -2)
	end
	if key == "return" and gameState == "mainMenu" and debugConsole == false then
		mLog("> ".. menuText)
		menuCmd(menuText)
		menuText = ""
	end
end

function menuInput(t)
	--Simple string manipulation crap
	if gameState == "mainMenu" and debugConsole == false then
		menuText = menuText .. t
	end
end

function menuCmd(cmd)
	--Crap to execute when ordered to crap
	if cmd == "help" then
		mLog("begin, configure, save, credits, cls")
	elseif cmd == "begin" then
		gameState = "playing"
	elseif cmd == "cls" or cmd == "clear" then
		clearLog()
	elseif cmd == "configure" then
		mLog("vSync, fullscreen, borderless, antialiasing")
	elseif cmd == "save" then
		mLog("newSave, deleteSave, checkSaves")
	elseif cmd == "newSave" then
		love.filesystem.write("save.txt", "testing line 1\nTesting line 2")
		if love.filesystem.exists("save.txt") then
			mLog("New file created successfully")
		else
			mLog("Error: file failed to create")
		end


	--MiniGames crap
	elseif cmd == "minigames" then
		mLog("zork, tictactoe")
	elseif cmd == "zork" then
		mLog("To Be Implemented...")
	elseif cmd == "tictactoe" then
		mLog("To Be Implemented...")
		
		
		
		
		
	--Social Interaction crap
	elseif cmd == "thank you" or cmd == "Thank you" or cmd == "Thank You" or cmd == "Thank you." or cmd == "Thank You." or cmd == "thank you." then
		mLog("You're welcome")
		
		
		
	elseif cmd == "exit" then
		love.event.quit()
	else
		mLog("Command Unrecognized")
	end
end